#include <Stepper.h>

//////////////////////////////////////////////////////////////////
//©2011 bildr
//Released under the MIT License - Please reuse change and share
//Using the easy stepper with your arduino
//use rotate and/or rotateDeg to controll stepper motor
//speed is any number from .01 -> 1 with 1 being fastest - 
//Slower Speed == Stronger movement
/////////////////////////////////////////////////////////////////


#define DIR_PIN 2
#define STEP_PIN 3

boolean done = true;
int numRotations = 15;
char val;
int ledPin = 13;
float rotAmt = 120;
float motor_speed = 0.1;

void setup() { 
  pinMode(DIR_PIN, OUTPUT); 
  pinMode(STEP_PIN, OUTPUT); 
  pinMode(ledPin, OUTPUT);
  Serial.begin(9600);
} 

void loop(){
  
  if(Serial.available()){
    val = Serial.read();
  }
  
  if(val=='L'){
    digitalWrite(ledPin, HIGH);
    // move the motor
    rotateDeg(rotAmt, motor_speed);
  }else if(val=='R'){
    rotateDeg(-rotAmt, motor_speed);
    digitalWrite(ledPin, HIGH);
  }
  
//    if(!done){
//      startRevolution();      
//    }



//  //rotate a specific number of degrees 
//  rotateDeg(360, 1); 
//  delay(1000);
//
//  rotateDeg(-360, .1);  //reverse
//  delay(1000); 
//
//
//  //rotate a specific number of microsteps (8 microsteps per step)
//  //a 200 step stepper would take 1600 micro steps for one full revolution
//  rotate(1600, .5); 
//  delay(1000); 
//
//  rotate(-1600, .25); //reverse
//  delay(1000); 
}

void startRevolution(){
  for(int i =0; i<numRotations; i++){
      // rotates the servo 360 degrees, stopping 8 times
      rotateDeg(24, 0.1);
      delay(1000);
  }
  done = true;
}

void rotate(int steps, float speed){ 
  //rotate a specific number of microsteps (8 microsteps per step) - (negitive for reverse movement)
  //speed is any number from .01 -> 1 with 1 being fastest - Slower is stronger
  int dir = (steps > 0)? HIGH:LOW;
  steps = abs(steps);

  digitalWrite(DIR_PIN,dir); 

  float usDelay = (1/speed) * 70;

  for(int i=0; i < steps; i++){ 
    digitalWrite(STEP_PIN, HIGH); 
    delayMicroseconds(usDelay); 

    digitalWrite(STEP_PIN, LOW); 
    delayMicroseconds(usDelay); 
  } 
} 

void rotateDeg(float deg, float speed){ 
  //rotate a specific number of degrees (negitive for reverse movement)
  //speed is any number from .01 -> 1 with 1 being fastest - Slower is stronger
  int dir = (deg > 0)? HIGH:LOW;
  digitalWrite(DIR_PIN,dir); 

  int steps = abs(deg)*(1/0.225);
  float usDelay = (1/speed) * 70;

  for(int i=0; i < steps; i++){ 
    digitalWrite(STEP_PIN, HIGH); 
    delayMicroseconds(usDelay); 

    digitalWrite(STEP_PIN, LOW); 
    delayMicroseconds(usDelay); 
  } 
}
